var KTSDKUtils;
(function (KTSDKUtils) {
    /** 获取请求列表 */
    function GetQueryString(name, target) {
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
        var r = target.substr(1).match(reg);
        return (r && r[2]) || null;
    }
    KTSDKUtils.GetQueryString = GetQueryString;
    function AndroidOrIos() {
        var UA = window.navigator.userAgent;
        if (/Android|HTC/i.test(UA) || !!(window.navigator['platform'] + '').match(/Linux/i))
            UA = 'and';
        else if (/iPad/i.test(UA) || /iPod|Iphone/i.test(UA))
            UA = 'ios';
        else
            UA = 'h5';
        return UA;
    }
    KTSDKUtils.AndroidOrIos = AndroidOrIos;
    /**
     * 将网页参数转换成json数据
     * @param parm
     */
    function urlParm2Json(parm) {
        var arr = []; //存储参数的数组
        var res = {}; //存储最终转换的json数据
        if (parm[0] == '?')
            parm = parm.substr(1);
        // parm = parm.split('?')[0];
        arr = parm.split('&');
        for (var i = 0; i < arr.length; i++) {
            if (arr[i].indexOf('=') != -1) {
                var str = arr[i].split('=');
                res[str[0]] = str[1] || '';
            }
            else {
                res[arr[i]] = '';
            }
        }
        return res;
    }
    KTSDKUtils.urlParm2Json = urlParm2Json;
    function encodeBase64(str) {
        var _keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;
        var input = _utf8_encode(str);
        while (i < input.length) {
            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);
            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;
            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            }
            else if (isNaN(chr3)) {
                enc4 = 64;
            }
            output = output +
                _keyStr.charAt(enc1) + _keyStr.charAt(enc2) +
                _keyStr.charAt(enc3) + _keyStr.charAt(enc4);
        }
        return output;
    }
    KTSDKUtils.encodeBase64 = encodeBase64;
    function decodeBase64(input) {
        var _keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;
        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
        while (i < input.length) {
            enc1 = _keyStr.indexOf(input.charAt(i++));
            enc2 = _keyStr.indexOf(input.charAt(i++));
            enc3 = _keyStr.indexOf(input.charAt(i++));
            enc4 = _keyStr.indexOf(input.charAt(i++));
            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;
            output = output + String.fromCharCode(chr1);
            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }
        }
        output = _utf8_decode(output);
        return output;
    }
    KTSDKUtils.decodeBase64 = decodeBase64;
    // private method for UTF-8 encoding  
    function _utf8_encode(string) {
        string = string.replace(/\r\n/g, "\n");
        var utftext = "";
        for (var n = 0; n < string.length; n++) {
            var c = string.charCodeAt(n);
            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if ((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }
        }
        return utftext;
    }
    // private method for UTF-8 decoding  
    function _utf8_decode(utftext) {
        var string = "";
        var i = 0;
        var c1, c2, c3;
        var c = c1 = c2 = 0;
        while (i < utftext.length) {
            c = utftext.charCodeAt(i);
            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            }
            else if ((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i + 1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            }
            else {
                c2 = utftext.charCodeAt(i + 1);
                c3 = utftext.charCodeAt(i + 2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }
        }
        return string;
    }
    function sendAjax(data, type, url, okcall, failcall, isJsondata) {
        if (type === void 0) { type = 'GET'; }
        if (isJsondata === void 0) { isJsondata = false; }
        var ajax = new XMLHttpRequest();
        ajax.open(type, url, true);
        ajax.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
        ajax.onreadystatechange = function () {
            if (ajax.readyState === 4) {
                if (ajax.status === 200) {
                    var result = '';
                    try {
                        result = JSON.parse(ajax.responseText);
                    }
                    catch (error) {
                        result = ajax.responseText;
                    }
                    if (typeof (okcall) == 'function') {
                        okcall(result, data);
                    }
                }
                else {
                    if (typeof (failcall) == 'function') {
                        failcall(result);
                    }
                }
            }
        };
        if (isJsondata) {
            ajax.send(data);
            return;
        }
        if (typeof data == 'string') {
            ajax.send(data);
        }
        else {
            ajax.send(JSON.stringify(data));
        }
    }
    KTSDKUtils.sendAjax = sendAjax;
    function PostFrom(url, data, okcall, failcall) {
        var ajax = new XMLHttpRequest();
        ajax.open("post", url, true);
        ajax.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
        ajax.responseType = "json";
        ajax.onreadystatechange = function () {
            if (ajax.readyState === 4) {
                if (ajax.status === 200) {
                    var result = '';
                    try {
                        result = JSON.parse(ajax.responseText);
                    }
                    catch (error) {
                        result = ajax.responseText;
                    }
                    if (typeof (okcall) == 'function') {
                        okcall(result, data);
                    }
                }
                else {
                    if (typeof (failcall) == 'function') {
                        failcall(result);
                    }
                }
            }
        };
        ajax.responseType = "json";
        var tUrl = "";
        //添加参数
        for (var item in data) {
            tUrl += item + "=" + data[item] + "&";
        }
        if (data) {
            tUrl = tUrl.substr(0, tUrl.length - 1);
        }
        console.log(tUrl);
        ajax.send(tUrl);
    }
    KTSDKUtils.PostFrom = PostFrom;
})(KTSDKUtils || (KTSDKUtils = {}));
var KTSDKDefine;
(function (KTSDKDefine) {
    /**
     * 错误类型定义
     */
    var ErrorCode;
    (function (ErrorCode) {
        /** 正常返回 */
        ErrorCode[ErrorCode["SUCCESS"] = 0] = "SUCCESS";
        /** 携带错误详情 */
        ErrorCode[ErrorCode["Error"] = 1] = "Error";
    })(ErrorCode = KTSDKDefine.ErrorCode || (KTSDKDefine.ErrorCode = {}));
    var ADType;
    (function (ADType) {
        // Banner(APP界面顶部、中部或底部展现的多形态广告样式)
        ADType[ADType["ADTYPE_BANNER"] = 0] = "ADTYPE_BANNER";
        // 插屏(类似于开屏广告,应用于一个新的广告页)
        ADType[ADType["ADTYPE_CUSTOM"] = 1] = "ADTYPE_CUSTOM";
        // 激励视频
        ADType[ADType["ADTYPE_VIDEO"] = 2] = "ADTYPE_VIDEO";
    })(ADType = KTSDKDefine.ADType || (KTSDKDefine.ADType = {}));
    /**
     * 支付内容定义
     */
    var PayInfo = /** @class */ (function () {
        function PayInfo() {
            // 商品ID
            this.item_id = "";
            // 商品名称
            this.item_name = "";
            // 商品描述
            this.item_desc = "";
            // 购买数量
            this.item_num = "";
            // 价格(分)
            this.item_price = "";
            // 货币兑换比例(数量/元)
            this.ratio = "";
            // 大区ID
            this.zone_id = "";
            // 大区名
            this.zone_name = "";
            // 服务器ID
            this.svr_id = "";
            // 服务器名
            this.svr_name = "";
            // 账号(uid)
            this.role_uid = "";
            // 角色ID(游戏内的ID)
            this.role_id = "";
            // 角色昵称
            this.role_name = "";
            // 角色等级
            this.role_level = "";
            // vip等级
            this.role_viplevel = "";
            // 角色转生等级
            this.role_turn = "";
            // 游戏订单号
            this.order = "";
            // 透传字符
            this.ext = "";
        }
        return PayInfo;
    }());
    KTSDKDefine.PayInfo = PayInfo;
    /**
     * 上报内容定义
     */
    var SubmitInfo = /** @class */ (function () {
        function SubmitInfo() {
            // 角色ID
            this.role_id = "";
            // 角色昵称
            this.role_name = "";
            // 角色等级
            this.role_level = "";
            // 角色转生等级
            this.role_turn = "";
            // 大区ID
            this.zone_id = "";
            // 大区名
            this.zone_name = "";
            // 服务器ID
            this.svr_id = "";
            // 服务器名称
            this.svr_name = "";
            // 行会名称
            this.guild_id = "";
            // 行会名
            this.guild_name = "";
            // 人物元宝数量
            this.num_gold = "";
            // 角色创建时间(10位时间戳)
            this.role_ctime = "";
            // 角色升级时间(10位时间戳)
            this.role_ltime = "";
            // 特殊扩展(如埋点相关)
            this.ext = {};
        }
        return SubmitInfo;
    }());
    KTSDKDefine.SubmitInfo = SubmitInfo;
    /**
     * 上报类型枚举
     */
    var SubmitType;
    (function (SubmitType) {
        // 账号登录完成
        SubmitType[SubmitType["EVENT_ACCOUNT_LOGIN"] = 1] = "EVENT_ACCOUNT_LOGIN";
        // 创建角色
        SubmitType[SubmitType["EVENT_CREATE_ROLE"] = 2] = "EVENT_CREATE_ROLE";
        // 进入游戏
        SubmitType[SubmitType["EVENT_ENTER_GAME"] = 3] = "EVENT_ENTER_GAME";
        // 角色升级
        SubmitType[SubmitType["EVENT_LEVEL_UP"] = 4] = "EVENT_LEVEL_UP";
        // ADJUST埋点
        SubmitType[SubmitType["EVENT_ADJUST"] = 10] = "EVENT_ADJUST";
        // (扩展)其他类型的埋点上报,需要和安卓端协商类型
        SubmitType[SubmitType["EVENT_OTHER"] = 11] = "EVENT_OTHER";
    })(SubmitType = KTSDKDefine.SubmitType || (KTSDKDefine.SubmitType = {}));
    /**
     * 设备信息详情
     */
    var DeviceInfo = /** @class */ (function () {
        function DeviceInfo() {
            /** 设备类型(and|ios|h5) */
            this.os_type = "";
            /** 机型 */
            this.device_type = "";
            /** uuid唯一标识 */
            this.uuid = "";
            /** 渠道标识 */
            this.channel = "";
        }
        return DeviceInfo;
    }());
    KTSDKDefine.DeviceInfo = DeviceInfo;
})(KTSDKDefine || (KTSDKDefine = {}));
var CMKtSDK = /** @class */ (function () {
    function CMKtSDK() {
    }
    /**
     * SDK初始化接口
     * @param appid 中台分配的应用ID
     * @param initCallback 游戏初始化回调
     * @param onGameBackKey 应用触发返回键
     */
    CMKtSDK.init = function (appid, initCallback, onGameBackKey) {
        if (onGameBackKey === void 0) { onGameBackKey = null; }
        window['CMJSCB_BackKey'] = function (res) {
            onGameBackKey();
        }.bind(this);
        window['CMJSCB_init'] = function (res) {
            initCallback(res);
        }.bind(this);
        this.api.init(appid + "");
    };
    /**
     * 调用SDK登录接口
     * @param loginCallBack
     */
    CMKtSDK.login = function (loginCallBack) {
        window['CMJSCB_login'] = function (res) {
            loginCallBack(res);
        }.bind(this);
        this.api.login("");
    };
    /**
     * 调用SDK退出
     * @param logoutCallback 游戏退出回调
     */
    CMKtSDK.logout = function (logoutCallback) {
        window['CMJSCB_logout'] = function (res) {
            logoutCallback && logoutCallback();
        }.bind(this);
        this.api.logout("");
    };
    /**
     * 调用SDK上报
     * @param parm 游戏上报内容
     * @param submitCallBack SDK上报回调
     */
    CMKtSDK.submit = function (parm, submitCallBack) {
        window['CMJSCB_submit'] = function (res) {
            submitCallBack && submitCallBack(res);
        }.bind(this);
        this.api.submit(JSON.stringify(parm));
    };
    /**
     * 调用游戏支付
     * @param arg 支付参数
     * @param payCallBack 支付回调
     */
    CMKtSDK.pay = function (arg, payCallBack) {
        window['CMJSCB_pay'] = function (res) {
            payCallBack && payCallBack(res);
        }.bind(this);
        this.api.pay(JSON.stringify(arg));
    };
    /**
     * 切换账号
     * @param changeAccountCallBack 切换账号回调
     */
    CMKtSDK.changeAccount = function (changeAccountCallBack) {
        window['CMJSCB_changeAccount'] = function (res) {
            changeAccountCallBack && changeAccountCallBack();
        }.bind(this);
        this.api.changeAccount("");
    };
    /**
     * 显示广告
     * @param resCode 透传奖励码,回调原样返回
     * @param adType 广告类型
     * @param adCallBack 广告回调({播放成功/不成功,奖励码})
     */
    CMKtSDK.showAd = function (resCode, adType, adCallBack) {
        window['CMJSCB_ad'] = function (res) {
            adCallBack && adCallBack(res);
        }.bind(this);
        this.api.showAd(JSON.stringify({
            resCode: resCode,
            type: adType
        }));
    };
    /** 调用退出应用 */
    CMKtSDK.exitApp = function () {
        window['CMJSCB_exitApp'] = function (res) {
        }.bind(this);
        this.api.exitApp("");
    };
    /**
     * 获取商品ID
     * @param itemIdArray [8001,8002,8003]
     * @param callback [{id:com.xxx.8001,price:US$0.99}]
     */
    CMKtSDK.getItemPayId = function (itemIdArray, callback) {
        window['CMJSCB_getItemPayId'] = function (res) {
            callback && callback(res);
        }.bind(this);
        this.api.getItemPayId("");
    };
    CMKtSDK.api = window['CMNativeApi'];
    return CMKtSDK;
}());
